#Numeri di Fibonacci, versione ricorsiva di complessit esponenziale
#Programma che calcola il numero di Fibonacci di un numero in modo esponenziale in modo ricorsivo: dato #il valore n di cui si vuole calcolare il numero di Fibonacci si ha che:

#Fib(n) = Fib(n-1)+Fib(n-2) se n>1
#FiB(1) = 1
#Fib(0) = 1
#E quindi, in genere i numeri di fibonacci seguono la serie 1,1,2,3,5,8...
#Si procede quindi chiamando Fib(etichette della parte ricorsiva di un programma) sul valore n, si #decrementa n e si chiama Fib su n-1 e di nuovo su n-2, quindi si sommano i due risultati.

#Ogni volta che si procede ad una nuova chiamata bisogna memorizzare nella pila il valore su cui si va a #fare la nuova chiamata e l'inidirizzo a cui si vuole tornare alla chiusura di tale chiamata.

#Osservare che vengono usati rispettivamente i registri $a0 per passare il valore e $v0 per riportare il #risultato come indicato nelle convezioni dell'uso dei registri per le chiamate a procedura, ed inoltre #che il registro temporaneo $t0 va anch'esso salvato su stack.

	.data
elemento: .word 4 	# definizione del valore di cui si vuole calcolare il numero di fibonacci
	.text 
	.globl main
main:
	lw $a0,elemento	# si carica nel registro $a0 l'elemento (coi il valore 4)
	li $t1,1	# carico in $t1 la costante 1 necessaria al confronto ble
	jal Fib		# salto all'etichetta Fib e memorizzazione dell'indirizzo dell'istruzione
			# succesiva nel registro $ra (ove la sigla ra sta proprio pre return address)
	move $t0,$v0	# pone il contenuto del registro di ritorno ($v0) all'interno di $t0
	li $v0,10	# 
	syscall		# fine programma
Fib:
	ble $a0,$t1,esci# confronto pre vedere se il risultato attuale di n <= 1,salta a (fine) 
	subu $sp,$sp,12	# decremento 12 byte dello stack pointer
	sw $ra,4($sp)	# memorizzo l'idirizzo del return address nella pila 
	sw $a0,8($sp)	# memorizzo il valore di n nella pila
	sw $t0,12($sp)  # si pone il valore attuale nella pila 
	sub $a0,$a0,1	# n-1
	jal Fib		# calcolo del Fib(n-2)
	add $v0,$v0,$t0	# somma di Fib(n-1)+Fib(n-2)
	lw $t0,12($sp)	# recupero in $t0
	lw $a0,8($sp)	# recupero in $a0
	lw $ra,4($sp)	# recupero in $ra	
  	add $sp,$sp,12	# si aggiorna il valore della pila
	jr $ra		# ritorna al main
esci:			# si arriva qui se il valore attuale di $a0  1
	li $v0,1	# assegno il valore 1 al registro di ritorno valore
	jr $ra		# ritorna al main

# Osservazione: vengono effettuate 2 chiamate ricorsive a Fib, quindi la complessit sar dell'ordine di  # 2 alla n 